/*
 * Copyright (c) 2015, Oracle and/or its affiliates. All rights reserved.
 */
package com.tasktop.c2c.server.common.service;

/**
 * Exception describing failed migration.
 *
 * @author Jan Taus <jan.taus@oracle.com>
 */
public class MigrationException extends Exception {

    private final boolean recoverable;

    public MigrationException(boolean recoverable, String message) {
        super(message);
        this.recoverable = recoverable;
    }

    public MigrationException(boolean recoverable, String message, Throwable cause) {
        super(message, cause);
        this.recoverable = recoverable;
    }

    public MigrationException(boolean recoverable, Throwable cause) {
        super(cause);
        this.recoverable = recoverable;
    }

    public boolean isRecoverable() {
        return recoverable;
    }
}
